routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect('login');
});

Route::group(['middleware' => 'auth', 'namespace' => 'Admin'], function () {
    Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
    Route::get('/profile/me', 'UserController@profile')->name('users.profile');
    Route::get('/request-absent/{request_absent}/approve', 'RequestAbsentController@approve')->name('request-absent.approve');
    Route::post('/request-absent/approve-or-reject', 'RequestAbsentController@approveOrRejectAll')->name('request-absent.approve-or-reject');
    Route::get('/overtimes/{overtime}/approve', 'OvertimeController@approve')->name('overtimes.approve');
    Route::post('/overtime/approve-or-reject', 'OvertimeController@approveOrRejectAll')->name('overtime.approve-or-reject');
    Route::resource('/users', 'UserController');
    Route::resource('/request-absent', 'RequestAbsentController');
    Route::resource('/overtimes', 'OvertimeController');
    Route::resource('/config', 'ConfigController')->middleware('admin');
    Route::resource('/notification', 'NotificationController')->middleware('admin');
    Route::resource('/roles', 'RoleController')->middleware('admin');
    Route::resource('/work-titles', 'WorkTitleController')->middleware('admin');
    Route::get('/timesheets', 'DashboardController@index');
    Route::get('/logout', 'AuthController@logout');
    Route::get('/password/change', 'AuthController@changePasswordEdit')->name('change-password.edit');
    Route::put('/password/change', 'AuthController@changePasswordUpdate')->name('change-password.update');
    Route::get('timesheet/getData', '\App\Http\Controllers\Admin\TimeSheetController@getData')->name('timesheet.getData');
    Route::resource('national-day', '\App\Http\Controllers\Admin\NationalDayController')->middleware('admin');
    Route::resource('timesheet', '\App\Http\Controllers\Admin\TimeSheetController')->except(['show']);
    Route::resource('comments', '\App\Http\Controllers\Admin\CommentController');
    Route::put('timesheet/update-paid-leave/{id}', '\App\Http\Controllers\Admin\TimeSheetController@updatePaidLeave')
            ->name('timesheet.updatePaidLeave');
    Route::post('timesheet/upload-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@uploadTimesheet')
            ->name('timesheet.uploadTimesheet')
            ->middleware('can:timesheet.uploadTimesheet');
    Route::get('timesheet/export-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@ExportTimesheet')
            ->name('timesheet.exportTimesheet');
    Route::get('timesheet/create', '\App\Http\Controllers\Admin\TimeSheetController@create')
        ->name('timesheet.create')->middleware('can:timesheet.create');
    Route::get('timesheet/edit/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@edit')
        ->name('timesheet.edit')->middleware('can:timesheet.update');
    Route::delete('timesheet/destroy/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@destroy')
        ->name('timesheet.destroy')->middleware('can:timesheet.delete');
    Route::resource('/position', 'PositionController')->middleware('admin');
    Route::post('timesheet/update-all-month', '\App\Http\Controllers\Admin\TimeSheetController@updateMonthAll')
            ->name('timesheet.updateMonthAll')->middleware('admin');
    Route::post('users/upload-users', '\App\Http\Controllers\Admin\UserController@uploadUsers')
            ->name('users.uploadUsers')
            ->middleware('admin');
    Route::get('request-absents/export', '\App\Http\Controllers\Admin\RequestAbsentController@exportRequestAbsent')
            ->name('request-absent.exportRequestAbsent');
    Route::get('overtime/export', '\App\Http\Controllers\Admin\OvertimeController@exportOvertime')
            ->name('overtime.exportOvertime');
});

app/Models/Notifications.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Notifications extends Model
{
    use HasFactory;

    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'notifications';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'title', 'content', 'start_time', 'image', 'status'
    ];

    public function getList($condition = [])
    {
        return $this->getNotificationWithCondition($condition)->get();
    }

    protected function getNotificationWithCondition($condition = [])
    {
        $query = Notifications::query();
        $query->where('status', '=', 1);

        return $query;
    }
}

app/Http/Controllers/API/NotificationController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\Notifications;
use App\Models\NotificationUser;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class NotificationController extends BaseController
{
    /**
     * List notification
     * @return \Illuminate\Http\JsonResponse
     */
    public function index()
    {
        $notificationModel = new Notifications();
        $notificationUserModel = new NotificationUser();
        $notifications = $notificationModel->getList();
        $notificationUsers = $notificationUserModel->getList(['user_id' => $this->userId]);
        $notificationIds = array_column($notificationUsers->toArray(), 'notification_id');
        foreach ($notifications as $notification){
            $notification->readed = in_array($notification->id, $notificationIds);
        }

        return send_success($notifications);
    }

    /**
     * Detail notification
     * @param $id
     */
    public function detail($id)
    {
        $notificationModel = new Notifications();
        $notification = $notificationModel->find($id);
        if ($notification){
            try {
                NotificationUser::updateOrCreate(
                    [
                        'notification_id' => $id,
                        'user_id' => $this->userId
                    ],
                    [
                        'notification_id' => $id,
                        'user_id' => $this->userId
                    ]
                );
                $notification->readed = true;
                return send_success($notification);
            } catch (\Exception $exception){
                Log::error('Update notification user: '.$exception->getMessage());
                return send_error('E0301');
            }
        }

        return send_error('E0400');
    }
}

app/Http/Controllers/Admin/NotificationController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\NotificationRequest;
use App\Models\Notifications;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class NotificationController extends Controller
{
    protected $notificationModel;
    public function __construct()
    {
        $this->notificationModel = new Notifications();
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $page_title = __('layouts.notification');
        $notifications = $this->notificationModel->query()->orderBy('id', 'desc')->paginate(30);
        return view('admin.notification.index', compact('page_title', 'notifications'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $page_title = __('layouts.create_notification');;
        return view('admin.notification.create', compact('page_title'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param NotificationRequest $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(NotificationRequest $request)
    {
        $input = $request->validated();
        try {
            $notification = $this->notificationModel->fill($input);
            $notification->save();

            return redirect()->route('notification.index')
                ->with([
                    'success' => true,
                    'message' => __('messages.create.success')
                ]);
        }catch (\Exception $exception) {
            Log::error('Create Notification: '. $exception->getMessage());
            return redirect()->route('notification.index')
                ->with([
                    'success' => false,
                    'message' => __('messages.create.error')
                ]);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Notifications $notification
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function edit(Notifications $notification)
    {
        $page_title = __('layouts.edit_notification');
        return view('admin.notification.edit', compact('page_title', 'notification'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param NotificationRequest $request
     * @param Notifications $notification
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(NotificationRequest $request, Notifications $notification)
    {
        $input = $request->validated();
        try {
            $notification->update($input);

            return redirect()->route('notification.index')
                ->with([
                    'success' => true,
                    'message' => __('messages.create.success')
                ]);
        }catch (\Exception $exception) {
            Log::error('Update Notification: '. $exception->getMessage());
            return redirect()->route('notification.index')
                ->with([
                    'success' => false,
                    'message' => __('messages.create.error')
                ]);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Notifications $notification
     * @return \Illuminate\Http\RedirectResponse
     */
    public function destroy(Notifications $notification)
    {
        try {
            $notification->delete();
            $success = true;
            $message = __('messages.delete.success');
            return redirect()->route('notification.index')
                ->with(['success' => $success, 'message' => $message]);
        }catch (\Exception $e){
            logger()->error('Delete notification error: ' . $e->getMessage());
            $success = false;
            $message = __('messages.delete.error');
            return redirect()->route('notification.index')
                ->with(['success' => $success, 'message' => $message]);
        }
    }
}

resources/views/admin/notification/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container-fluid pb-3">
        @include('layouts.alert')
        <div class="card p-3 mb-3 rounded">
            <form method="POST" action="{{ route('notification.store') }}">
                @csrf
                <div class="form-group row">
                    <label for="inputTitleId" class="col-sm-2 col-form-label">{{ __('layouts.title') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <input class="form-control @error('title') is-invalid @enderror" type="text" name="title"
                               value="{{ old('title') }}" id="inputTitleId">
                        @error('title')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="form-group row">
                    <label for="inputContentId" class="col-sm-2 col-form-label">{{ __('layouts.content') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <textarea name="content" class="form-control @error('content') is-invalid @enderror"
                                  id="inputContentId" rows="5">{{ old('content') }}</textarea>
                        @error('content')
                            <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="form-group row">
                    <label for="inputStartTime" class="col-sm-2 col-form-label">{{ __('layouts.send_schedule') }}
                        <code>*</code></label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                        </div>
                        <input type="text" class="form-control date-time @error('start_time') is-invalid @enderror" id="inputStartTime"
                               placeholder="yyyy/mm/dd --:--" name="start_time"
                               value="{{ old('start_time', \Carbon\Carbon::now()->format('Y/m/d H:i')) }}" autocomplete="off">
                        @error('start_time')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="d-flex justify-content-end">
                    <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.create') }}">
                    <a class="btn btn-dark ml-2 btn-width-default" href="{{ route('notification.index') }}">{{ __('layouts.close') }}</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/admin/notification/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container-fluid pb-3">
        @include('layouts.alert')
        <div class="card p-3 mb-3 rounded">
            <form method="POST" action="{{ route('notification.update', $notification->id) }}">
                @csrf
                @method('PUT')
                <div class="form-group row">
                    <label for="inputTitleId" class="col-sm-2 col-form-label">{{ __('layouts.title') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <input class="form-control @error('title') is-invalid @enderror" type="text" name="title"
                               value="{{ old('title', $notification->title) }}" id="inputTitleId">
                        @error('title')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="form-group row">
                    <label for="inputContentId" class="col-sm-2 col-form-label">{{ __('layouts.content') }}
                        <code>*</code>
                    </label>
                    <div class="col-sm-10 input-group">
                        <textarea name="content" class="form-control @error('content') is-invalid @enderror"
                                  id="inputContentId" rows="5">{{ old('content', $notification->content) }}</textarea>
                        @error('content')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="form-group row">
                    <label for="inputStartTime" class="col-sm-2 col-form-label">{{ __('layouts.send_schedule') }}
                        <code>*</code></label>
                    <div class="col-sm-10 input-group">
                        <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                        </div>
                        <input type="text" class="form-control date-time @error('start_time') is-invalid @enderror" id="inputStartTime"
                               placeholder="yyyy/mm/dd --:--" name="start_time"
                               value="{{ old('start_time', \Carbon\Carbon::make($notification->start_time)->format('Y/m/d H:i')) }}" autocomplete="off">
                        @error('start_time')
                        <div class="invalid-feedback">{{ $message }}</div>
                        @enderror
                    </div>
                </div>

                <div class="d-flex justify-content-end">
                    <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.save') }}">
                    <a class="btn btn-dark ml-2 btn-width-default" href="{{ route('notification.index') }}">{{ __('layouts.close') }}</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/admin/notification/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container-fluid pb-3">
        <div class="card p-3 rounded-lg">
            <div class="row">
                <div class="col-md-8">
                    <a class="btn btn-primary text-nowrap btn-width-default" href="{{ route('notification.create') }}">{{ __('layouts.add') }}</a>
                </div>
{{--                <div class="col-md-4">--}}
{{--                    <form class="form-inline my-lg-0 justify-content-end" method="GET" action="{{ route('users.index') }}">--}}
{{--                        <input class="form-control mr-sm-2 mt-2" type="search" placeholder="{{ __('layouts.user_search_key') }}" aria-label="Search" name="search" value="{{ $search }}">--}}
{{--                        <button class="btn btn-dark mt-2 btn-width-default" type="submit">{{ __('layouts.search') }}</button>--}}
{{--                    </form>--}}
{{--                </div>--}}
            </div>
            @include('layouts.alert')
            <div class="table-responsive">
                <table class="table table-striped my-3 table-borderless table-striped-reverse">
                    <thead class="thead-dark">
                    <tr>
                        <th>#</th>
                        <th>{{ __('layouts.title') }}</th>
                        <th>{{ __('layouts.send_schedule') }}</th>
                        <th>{{ __('layouts.status') }}</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    @if (count($notifications) == 0)
                        <tr>
                            <td class="text-danger no-data" colspan="8">{{ __('messages.no_data') }}</td>
                        </tr>
                    @endif
                    @foreach ($notifications as $notification)
                        <tr>
                            <td>{{ ($notifications->currentPage() - 1) * $notifications->perPage() + $loop->iteration }}</td>
                            <td>{{ $notification->title }}</td>
                            <td>{{ $notification->start_time }}</td>
                            <td>{{ $notification->status ? __('layouts.sent') : __('layouts.wait') }}</td>
                            <td>
                                <div class="d-flex justify-content-right">
                                    @if(!$notification->status)
                                    <a class="btn btn-primary py-0 px-1 mx-2"
                                       href="{{ route('notification.edit', $notification->id) }}"
                                       data-toggle="tooltip" title="{{ __('layouts.edit') }}">
                                        <i class="fas fa-pen"></i>
                                    </a>
                                    <form class="inline-block" method="POST" action="{{ route('notification.destroy', $notification->id) }}">
                                        <input type="hidden" name="_method" value="DELETE">
                                        <input type="hidden" name="_token" value="{{ csrf_token() }}" />
                                        <button class="btn btn-danger py-0 px-1 delete" data-toggle="tooltip" title="{{ __('layouts.delete') }}">
                                            <i class="fas fa-trash-alt"></i>
                                        </button>
                                    </form>
                                    @endif
                                </div>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
            @include('layouts.paginate', ['paginate' => $notifications])
        </div>
    </div>
@endsection